﻿/*
 * Datum: 23.09.2007
 * Zeit: 16:45
 * 
 */

using System;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Booter;
using System.IO.Ports;
using System.Collections;
using System.Diagnostics;
using System.ComponentModel;

namespace BooterCE.Httpd
{
	/// <summary>
	/// Description of Class1.
	/// </summary>
	public class HttpServer
	{
        const int ERROR_FILE_NOT_FOUND = 2;
        const int ERROR_ACCESS_DENIED = 5;

        private int portNum = 8080;
		private String _rootPath;
		private TcpListener listener;
		System.Threading.Thread Thread;
		public string Name = "X300T-Httpd/1.0";

		public HttpServer(int thePort, String rootPath)
		{
			portNum = thePort;
			_rootPath = rootPath;
		}

		public void Listen()
		{
			bool done = false;
			
			string hostname = Dns.GetHostName();
			IPHostEntry ipHost = Dns.GetHostEntry(hostname);
			
			IPEndPoint endpoint = new IPEndPoint(IPAddress.Any, portNum);
			listener = new TcpListener(endpoint);
			listener.Start();
			Log.debug("HTTP Server listening On: " + ipHost.AddressList[0].ToString() + ":" + portNum.ToString());

			while (!done)
			{
				try
				{
					Log.debug("Waiting for connection...");
					HttpRequest newRequest = new HttpRequest(listener.AcceptTcpClient(),this);
					Thread Thread = new Thread(new ThreadStart(newRequest.Process));
					Thread.Name = "HTTP Request";
					Thread.Start();
				}
				catch (Exception e)
				{
					Log.debug("Error while handling httprequest " + e);
				}
			}
		}

		public void Start()
		{
			try
			{
				this.Thread = new Thread(new ThreadStart(this.Listen));
                this.Thread.Name = "HTTPd";
				this.Thread.Start();
			}
			catch (Exception e)
			{
				Log.debug("httpd start thread failed:"+e);
			}
		}

		public void Stop()
		{
			listener.Stop();
			this.Thread.Abort();
		}

		public void OnResponse(ref HTTPRequestStruct rq, ref HTTPResponseStruct rp)
		{
			rp.status = 200;
			if (rq.URL.StartsWith("/command/"))
		    {
				string command = rq.URL.Substring(9);
				handleCommand(command, ref rq, ref rp);
		    }
			else
			{
                listCommands(ref rp);
			}
		}

        private void listCommands(ref HTTPResponseStruct rp)
        {
            TextWriter result = new StringWriter();
            result.Write("<html>\n<head>\n<title>X300T Remote Access</title><body>");
            result.Write("<H1>X300T Remote Access</H1>");
            Memory.MemoryStatus status = Memory.getStatus();

            result.Write("Physical Memory: " + status.AvailablePhysical + " / " + status.TotalPhysical +" <BR>");
            result.Write("Virtual Memory: " + status.AvailableVirtual + " / " + status.TotalVirtual + " <BR>");
            result.Write("Memory Load: " + status.MemoryLoad + "% <BR><HR>");

            if (App.vncPid != -1)
            {
                result.Write("<b>VNC Server</b> running with PID:" + App.vncPid + " <BR>");
            }

            if (App.ftpPid != -1)
            {
                result.Write("<b>VNC Server</b> running with PID:" + App.ftpPid + " <BR>");
            }

            if (App.debugServerPid != -1)
            {
                result.Write("<b>Debug Server</b> running with PID:" + App.debugServerPid + " <BR>");
            }

            result.Write("<BR><a href='/command/restartTv2Server'>Restart Tv2Server Application</a> (Current PID:"+App.tv2serverPid+")<BR>");
            result.Write("<a href='/command/restartTv2Client'>Restart Tv2Client Application</a> (Current PID:" + App.tv2clientPid + ")<BR>");
            result.Write("<a href='/command/browse'>Browse FileSystem</a><BR>");
            ASCIIEncoding ascii = new ASCIIEncoding();
            rp.BodyData = ascii.GetBytes(result.ToString());
            rp.BodySize = rp.BodyData.Length;				
        }

		private void listDir(String dir, ref HTTPResponseStruct rp)
		{
			TextWriter result = new StringWriter();
			result.Write("<html>\n<head>\n<title>Listing of " + dir +"</title><body>");
			writeListHeader(result);
			DirectoryInfo root = new DirectoryInfo(_rootPath);
			int offset = root.FullName.Length;

			DirectoryInfo di = new DirectoryInfo(dir);
			FileSystemInfo[] dirs = di.GetDirectories();
            Array.Sort(dirs, new SortDirs());
			foreach (DirectoryInfo diNext in dirs)
			{
				writeListLine(result, diNext.FullName.Substring(offset), diNext.Name, diNext.LastWriteTime.ToString(), "DIR");
			}

			FileSystemInfo[] files = di.GetFiles();
            Array.Sort(files, new SortFiles());
			foreach (FileInfo diNext in files)
			{
				writeListLine(result, diNext.FullName.Substring(offset), diNext.Name, diNext.LastWriteTime.ToString(), diNext.Length.ToString());
			}
			result.Write("</table></body></html>");
			
			ASCIIEncoding ascii = new ASCIIEncoding();
			rp.BodyData = ascii.GetBytes(result.ToString());
			rp.BodySize = rp.BodyData.Length;
		}
		
		private void writeListHeader(TextWriter document)
		{
			document.Write("<table border=0 cellpadding=0 cellspacing=0 width=100%>");
			document.Write("<tr bgcolor=#ccffff>");

			document.Write("<th align=left>Filename</th>");
			document.Write("<th>&nbsp;&nbsp;</th>");

            document.Write("<th align=right>Size</th>");
            document.Write("<th>&nbsp;&nbsp;</th>");
            
            document.Write("<th align=left>Date</th>");
			document.Write("<th>&nbsp;&nbsp;</th>");

			document.Write("</tr>\n");
		}
		
		private void writeListLine(TextWriter document, String path, String file, String date, String size)
		{
			document.Write("<tr>");
            document.Write("<td><a href=\"/command/browse/" + path + "\">" + file + "</a></td>");
			document.Write("<td></td>");
            document.Write("<td align=right>" + size + "</td>");
            document.Write("<td></td>");
            document.Write("<td>" + date + "</td>");
            if (file.ToLower().EndsWith(".exe"))
            {
                document.Write("<td><a href=\"/command/execute/" + path + "\">start</a></td>");
            }
            else
            {
                document.Write("<td></td>");
            }
			document.Write("</tr>\n");
		}
		
		private void handleCommand(string command, ref HTTPRequestStruct rq, ref HTTPResponseStruct rp)
		{
			if (command.StartsWith("boxid"))
            {
	            byte[] buffer = new byte[0x18];
                App.GetBoxUniqueID(buffer, buffer.Length);
            	rp.BodyData = buffer;
            	rp.BodySize = rp.BodyData.Length;
            }
            else if (command.StartsWith("restartTv2Server"))
            {
                App.RestartTV2Server();
            }
            else if (command.StartsWith("restartTv2Client"))
            {
                App.RestartTV2ClientCE();
            }
            else if (command.StartsWith("browse"))
            {
                browseFileSystem(ref rp, command);
            }
            else if (command.StartsWith("execute"))
            {
                executeFile(ref rp, command);
            }
            else
            {
                rp.BodyData = Encoding.ASCII.GetBytes("Command not implemented: '" + command + "'");
                rp.BodySize = rp.BodyData.Length;
            }
		}

        private void executeFile(ref HTTPResponseStruct rp, String command)
        {
            String file = "/";
            if (command.Length > 8)
            {
                file = command.Substring(8);
            }

            file = file.Replace('/', '\\');
            FileInfo fi = new FileInfo(file);
            if (fi.Exists)
            {
                Process myProcess = new Process();

                try
                {
                    // Get the path that stores user documents.

                    myProcess.StartInfo.FileName = fi.Name;
                    myProcess.StartInfo.WorkingDirectory = fi.DirectoryName;
                    //myProcess.StartInfo.Verb = "Print";
                    myProcess.StartInfo.UseShellExecute = true;
                    myProcess.Start();
                    rp.BodyData = Encoding.ASCII.GetBytes("Started application '" + fi.Name + "' with workdir: '" + fi.DirectoryName + "' with PID:" + myProcess.Id);
                }
                catch (Win32Exception e)
                {
                    if (e.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                    {
                        rp.BodyData = Encoding.ASCII.GetBytes(e.Message + ". Check the path.");
                    }
                    else if (e.NativeErrorCode == ERROR_ACCESS_DENIED)
                    {
                        rp.BodyData = Encoding.ASCII.GetBytes(e.Message +
                            ". You do not have permission to print this file.");
                    }
                    else
                    {
                        rp.BodyData = Encoding.ASCII.GetBytes(e.Message + " nativeCode:" + e.NativeErrorCode +" errorCode:"+ e.ErrorCode+
                            " base:"+e.GetBaseException().ToString());
                    }

                    try
                    {
                        myProcess.StartInfo.FileName = fi.Name;
                        myProcess.StartInfo.WorkingDirectory = fi.DirectoryName;
                        myProcess.StartInfo.UseShellExecute = false;
                        myProcess.Start();
                        rp.BodyData = Encoding.ASCII.GetBytes("Started application '" + fi.Name + "' with workdir: '" + fi.DirectoryName + "' with PID:" + myProcess.Id);
                    }
                    catch (Win32Exception e1)
                    {
                        rp.BodyData = Encoding.ASCII.GetBytes("2.try... "+e1.Message + " nativeCode:" + e1.NativeErrorCode +" errorCode:"+ e1.ErrorCode+
                            " base:"+e1.GetBaseException().ToString());
                    }

                }

//                int pid = App.LaunchApp(file, null);
                rp.BodySize = rp.BodyData.Length;
            }
            else
            {
                rp.BodyData = Encoding.ASCII.GetBytes("file does not exist '" + file + "' ");
                rp.BodySize = rp.BodyData.Length;
            }
        }

        private void browseFileSystem(ref HTTPResponseStruct rp, String command)
        {
            String file = "/";
            if (command.Length > 6)
            {
                file = command.Substring(6);
            }

            file = file.Replace('/', '\\');

            if (Directory.Exists(file))
            {
                listDir(file, ref rp);
            }
            else if (File.Exists(file))
            {
                rp.fs = new FileStream(file, FileMode.Open);
            }
            else
            {
                rp.BodyData = Encoding.ASCII.GetBytes("File not found");
                rp.BodySize = rp.BodyData.Length;
                rp.status = 404;
            }
        }
	}

    public class SortFiles : IComparer
    {
        public int Compare(object obj1, object obj2)
        {
            FileInfo f1 = (FileInfo)obj1;
            FileInfo f2 = (FileInfo)obj2;
            return f1.Name.CompareTo(f2.Name);
        }
    }

    public class SortDirs : IComparer
    {
        public int Compare(object obj1, object obj2)
        {
            DirectoryInfo d1 = (DirectoryInfo)obj1;
            DirectoryInfo d2 = (DirectoryInfo)obj2;

            return d1.Name.CompareTo(d2.Name);
        }
    }


}
