
namespace Booter
{
	using Microsoft.Win32;

	using System;
	using System.IO;
	using System.Net;
	using System.Runtime.InteropServices;
	using System.Threading;
	using System.Xml;
    using System.IO.Ports;
    using FTP_Server;
    using BooterCE.Httpd;
    using Telnet;

	internal class App
	{
		public static readonly string RootPath = @"\Hard Disk";
        public static readonly string appPathNK = @"\windows\TV2ClientCE.exe";
        public static readonly string appPath = (RootPath + @"\TV2ClientCE\TV2ClientCE2.exe");
        public static readonly string appTempPath = (RootPath + @"\TV2ClientCE\TV2ClientCE2_new.exe");
        public static readonly string ftpAppPath = (RootPath + @"\win\ftpserver.exe");
        public static readonly string ftpAppPath2 = (@"\windows\ftpserver.exe");
        public static readonly string vncAppPath = (RootPath + @"\win\winvnc.exe");
        public static readonly string vncAppPath2 = @"\windows\winvnc.exe";

        public static readonly string debug1AppPath = (RootPath + @"\win\ConmanClient2.exe");
        public static readonly string debug1AppPath2 = @"\windows\ConmanClient2.exe";
        public static readonly string debug2AppPath = (RootPath + @"\win\DeviceAgentTransport.dll");
        public static readonly string debug2AppPath2 = @"\windows\DeviceAgentTransport.dll";
        public static readonly string debug3AppPath = (RootPath + @"\win\eDbgTL.dll");
        public static readonly string debug3AppPath2 = @"\windows\eDbgTL.dll";
        public static readonly string debug4AppPath = (RootPath + @"\win\TcpConnectionA.dll");
        public static readonly string debug4AppPath2 = @"\windows\TcpConnectionA.dll";
        public static readonly string debug5AppPath = (RootPath + @"\win\clientshutdown.exe");
        public static readonly string debug5AppPath2 = @"\windows\clientshutdown.exe";

        public static readonly string tv2ServerAppPath = (RootPath + @"\TV2ClientCE\tv2server.exe");
        public static readonly string tv2ServerAppTempPath = (RootPath + @"\TV2ClientCE\tv2server_new.exe");
		public static readonly string configFile = @"\tv2config.xml";
        public static readonly string contentPath = (RootPath + @"\TV2ClientCE\Content");
        public static readonly string sipcfgPath = "sipcfg.exe";
        public static Boolean _noNative = false;

        public static int tv2clientPid = -1;
        public static int tv2serverPid = -1;
        public static int vncPid = -1;
        public static int ftpPid = -1;
        public static int debugServerPid = -1;


		private static void Main(string[] args)
		{
			try
			{
                foreach( string arg in args )
                {
                    if (arg.Equals("no-native"))
                    {
                        _noNative = true;
                        Console.WriteLine("test");
                        break;
                    }
                }

				RealMain(args);
			}
			catch (Exception exception)
			{
                StreamWriter sw = new StreamWriter(@"\Hard Disk\BooterCE.txt");
                sw.WriteLine("error while starting App:" + exception);
                sw.Close();
            }

			while (true)
			{
				Thread.Sleep(2000);
			}
		}

		private static void RealMain(string[] args)
		{
			tv2clientPid = -1;
            int pid = -1;
            int num2;

//            Log.debug("LoadHAL");
            TV2Engine_LoadHal();
//            Log.debug("do platfrom init");
            DoPlatformSpecificInitialization();

//            Log.debug("launching checkXos.exe");
            //pid = LaunchApp("CheckXos.exe", null);
            //for (int i = 0x2710; (i > 0) && AppRunning(pid); i -= num2)
            //{
            //    num2 = 0x3e8;
            //    Thread.Sleep(num2);
            //}
//            Log.debug("PrepDisks");
            PrepDisks();

            Log.initLog();
            Log.debug("starting up BooterCE2");

            PrepareRegistryForEthDriver("MAC86XX", "MAC86XX1", "Sigma Designs EM8624L/SMP8634 NIC", 0L, 0L, 0x26L);
            UpdateEthOptionsFromConfigFile();
            Log.debug("Loading network driver");
            if (!LoadEthDriver("MAC86XX", "MAC86XX1"))
            {
                Log.debug("Network driver failed!");
            }

            if (ReadUSBOptionsFromConfigFile())
            {
                if (!LoadUSBDriver())
                {
                    Log.debug("Load USBDriver failed!");
                }
                else
                {
                    Log.debug("Load USBDriver success");
                }
            }
            else
            {
                Log.debug("USBDriver disabled in config");
            }

            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\MAC86XX1\Parms", "HPNAMode", 0xff, RegistryValueKind.DWord);

            LaunchApp(sipcfgPath, null);
            WaitForDhcp();

//			new Updater().checkForUpdates();

            if (File.Exists(ftpAppPath))
            {
                File.Copy(ftpAppPath, ftpAppPath2);
                ftpPid = LaunchApp(ftpAppPath2, null);
                Log.debug("started MIPS FTP Server with PID:" + ftpPid);
            }

            if (ftpPid == -1)
            {
                FTPServer ftpd = new FTPServer();
                ftpd.Start();
            }

            if (File.Exists(vncAppPath))
            {
                Registry.SetValue(@"HKEY_CURRENT_USER\Software\RealVNC\WinVNC4", "SecurityTypes", "None", RegistryValueKind.String);
                File.Copy(vncAppPath, vncAppPath2);
                vncPid = LaunchApp(vncAppPath2, null);
            }

            if (File.Exists(debug1AppPath))
            {
                // always accept remote debug connection
                Registry.SetValue(@"HKEY_LOCAL_MACHINE\System", "CoreConOverrideSecurity", 1, RegistryValueKind.DWord);
                File.Copy(debug1AppPath, debug1AppPath2);
                File.Copy(debug2AppPath, debug2AppPath2);
                File.Copy(debug3AppPath, debug3AppPath2);
                File.Copy(debug4AppPath, debug4AppPath2);
                File.Copy(debug5AppPath, debug5AppPath2);
                debugServerPid = LaunchApp(debug1AppPath2, null);
            }

			// some registry tweaks :)
			
            // allow to attach to any C# application that is started 
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\.NETCompactFramework\Managed Debugger", "AttachEnabled", 1, RegistryValueKind.DWord);
			// allow unsigned code to run  ... not sure if they have any effect
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "0000101a", 1, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "00001006", 1, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "00001001", 1, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "00001005", 28, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "00001007", 40, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "00001017", 90, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\security\policies\policies", "0000101b", 1, RegistryValueKind.DWord);

            if (File.Exists(tv2ServerAppPath))
            {
                tv2serverPid = LaunchApp(tv2ServerAppPath, null);
            }


			HttpServer server = new HttpServer(8000, @"\");
			server.Start();
			
			Telnetd telnetd = new Telnetd();
			telnetd.Start();

            if (File.Exists(appPath))
            {
                tv2clientPid = LaunchApp(appPath, null);
            }

            
            if (tv2clientPid == -1)
            {
                // if there is a startup problem with our own file, fallback to nk.bin app
                tv2clientPid = LaunchApp(appPathNK, null);
            }

		}

        public static String RestartTV2Server()
        {
            String result = "unkown";

            if (tv2serverPid == -1)
            {
                return "TV2Server is not started";
            }

            Log.debug("Restarting TV2Server...");
            int PID = -1;
            try
            {
                if (AppRunning(tv2serverPid))
                {
                    int num = 0x3e8;
                    Log.debug("Waiting for Application to exit...");
                    while ((num > 0) && AppRunning(tv2serverPid))
                    {
                        Log.debug(string.Format("{0} seconds", num / 0x3e8));
                        int millisecondsTimeout = 0x3e8;
                        Thread.Sleep(millisecondsTimeout);
                        num -= millisecondsTimeout;
                    }
                    if (AppRunning(tv2serverPid))
                    {
                        Log.debug("Killing application");
                        KillApp(tv2serverPid);
                    }
                }
                if (File.Exists(tv2ServerAppTempPath))
                {
                    if (File.Exists(tv2ServerAppPath))
                    {
                        // we have a new version... update
                        File.Delete(tv2ServerAppPath);
                        Log.debug("old Application file deleted");
                    }

                    Log.debug("Temporary uploaded File will be renamed...");

                    try
                    {
                        File.Move(tv2ServerAppTempPath, tv2ServerAppPath);
                        Log.debug("Done.");
                    }
                    catch (Exception e)
                    {
                        result = "could not rename temp file!    " + e;
                    }
                }
            }
            catch (Exception e)
            {
                result = "Problem in Update Procedure: " + e;
            }

            StartTV2Server();
            PID = tv2clientPid;
            result = "Started TV2Server. new PID is: " + PID;

            return result;
        }
		
		public static String RestartTV2ClientCE()
		{
            String result = "unkown";

            if (tv2clientPid == -1)
            {
                return "TV2Client is not started";
            }

			Log.debug("Restarting TV2Client...");
            int PID = -1;
			try
			{
				if (AppRunning(tv2clientPid))
				{
					int num = 0x3e8;
					Log.debug("Waiting for Application to exit...");
					while ((num > 0) && AppRunning(tv2clientPid))
					{
						Log.debug(string.Format("{0} seconds", num / 0x3e8));
						int millisecondsTimeout = 0x3e8;
						Thread.Sleep(millisecondsTimeout);
						num -= millisecondsTimeout;
					}
					if (AppRunning(tv2clientPid))
					{
						Log.debug("Killing application");
						KillApp(tv2clientPid);
					}
				}
				if (File.Exists(appTempPath))
				{
                    if (File.Exists(appPath))
                    {
                        // we have a new version... update
                        File.Delete(appPath);
                        Log.debug("old Application file deleted");
                    }

                    Log.debug("Temporary uploaded File will be renamed...");

                    try
                    {
                        File.Move(appTempPath, appPath);
                        Log.debug("Done.");
                    }
                    catch (Exception e)
                    {
                        result = "could not rename temp file!    " + e;
                    }
				}

                StartTV2();
                PID = tv2clientPid;
                result = "Started TV2Client. new PID is: " + PID;
			}
			catch (Exception e)
			{
				result = "Problem in Update Procedure: " + e;
			}

            return result;
		}

        public static int StartTV2()
        {
            tv2clientPid = LaunchApp(appPath, null);
            return tv2clientPid;
        }

        public static int StartTV2Server()
        {
            tv2serverPid = LaunchApp(tv2ServerAppPath, null);
            return tv2serverPid;
        }

        private static void PrepareRegistryForEthDriver(string MiniportName, string AdapterName, string DisplayName, ulong BusNum, ulong BusType, ulong IntNum)
        {
            byte[] buffer = new byte[] { 60, 9, 0x4d, 0x53, 70, 0x54, 0x5f, 0x49, 80, 0x54, 0x56 };
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + MiniportName, "DisplayName", DisplayName + " Miniport Driver");
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + MiniportName, "Group", "NDIS");
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + MiniportName, "ImagePath", MiniportName + ".dll");
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + MiniportName + @"\Linkage", "Route", AdapterName);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName, "DisplayName", DisplayName + "Adapter #1");
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms", "BusNumber", BusNum, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms", "BusType", BusType, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms", "InterruptNumber", IntNum, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms\TcpIp", "DhcpMaxRetry", -1, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms\TcpIp\DhcpSendOptions", "@", "");
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\" + AdapterName + @"\Parms\TcpIp\DhcpSendOptions", "60", buffer, RegistryValueKind.Binary);
        }

        private static void UpdateEthOptionsFromConfigFile()
        {
            ulong num = 0x58L;
            ulong num2 = 3L;
            if (System.IO.File.Exists(@"\Hard Disk\TV2ClientCE\Content\tv2config.xml"))
            {
                try
                {
                    XmlDocument document = new XmlDocument();
                    document.Load(@"\Hard Disk\TV2ClientCE\Content\tv2config.xml");
                    XmlNodeList elementsByTagName = document.GetElementsByTagName("NetworkConfig");
                    if ((elementsByTagName != null) && (elementsByTagName.Count > 0))
                    {
                        XmlAttributeCollection attributes = elementsByTagName[0].Attributes;
                        XmlAttribute attribute = attributes["IGMPVersion"];
                        if (attribute != null)
                        {
                            num2 = ulong.Parse(attribute.Value);
                            if ((num2 > 3L) || (num2 < 2L))
                            {
                                num2 = 3L;
                            }
                        }
                        attribute = attributes["DefaultTOSValue"];
                        if (attribute != null)
                        {
                            num = ulong.Parse(attribute.Value);
                            num &= (ulong)0xffL;
                        }
                    }
                }
                catch (Exception exception)
                {
                    Console.WriteLine("Caught exception {0}", exception);
                }
            }
            Console.WriteLine("Igmp V{0}, DefaultTOSValue={1}", num2, num);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\Tcpip\Parms", "DefaultTOSValue", num, RegistryValueKind.DWord);
            Registry.SetValue(@"HKEY_LOCAL_MACHINE\Comm\Tcpip\Parms", "IGMPVersion", num2 + ((ulong)1L), RegistryValueKind.DWord);
        }

        private static bool ReadUSBOptionsFromConfigFile()
        {
            if (System.IO.File.Exists(contentPath + configFile))
            {
                try
                {
                    XmlDocument document = new XmlDocument();
                    document.Load(contentPath + configFile);
                    XmlNodeList elementsByTagName = document.GetElementsByTagName("USBConfig");
                    if ((elementsByTagName != null) && (elementsByTagName.Count > 0))
                    {
                        XmlAttribute attribute = elementsByTagName[0].Attributes["Enable"];
                        if ((attribute != null) && (ulong.Parse(attribute.Value) == 1L))
                        {
                            Log.debug("ReadUSBOptionsFromConfigFile return true");
                            return true;
                        }
                    }
                }
                catch (Exception exception)
                {
                    Log.debug("Caught exception "+ exception);
                }
            }
            Log.debug("ReadUSBOptionsFromConfigFile return false");
            return false;
        }


		private enum CommandStatus
		{
			NotRun,
			InProgress,
			Success,
			Fail
		}

        public static bool AppRunning(int pid)
        {
            if (_noNative)
            {
                return false;
            }
            else
            {
                return X300T.AppRunning(pid);
            }
        }

        public static bool DoFormatVolume(string path)
        {
            if (_noNative)
            {
                return true;
            }
            else
            {
                return X300T.DoFormatVolume(path);
            }
        }

        public static void DoPlatformSpecificInitialization()
        {
            if (!_noNative)
            {
                X300T.DoPlatformSpecificInitialization();
            }
        }

        public static void FixContent(string name)
        {
            if (!_noNative)
            {
                X300T.FixContent(name);
            }
        }

        public static bool GetBoxUniqueID(byte[] buffer, int length)
        {
            if (_noNative)
            {
                return true;
            }
            else
            {
                return X300T.GetBoxUniqueID(buffer, length);
            }
        }

        public static void KillApp(int pid)
        {
            if (!_noNative)
            {
                X300T.KillApp(pid);
            }
        }

        public static int LaunchApp(string name, string cmdLine)
        {
            if (_noNative)
            {
                return 10;
            }
            else
            {
                return X300T.LaunchApp(name, cmdLine);
            }
        }

        public static bool LoadEthDriver(string MiniportName, string AdapterName)
        {
            if (_noNative)
            {
                return true;
            }
            else
            {
                return X300T.LoadEthDriver(MiniportName, AdapterName);
            }
        }

        public static bool LoadUSBDriver()
        {
            if (_noNative)
            {
                return true;
            }
            else
            {
                return X300T.LoadUSBDriver();
            }
        }

        public static void PrepDisks()
        {
            if (!_noNative)
            {
                X300T.PrepDisks();
            }
        }

        public static void Reboot()
        {
            if (!_noNative)
            {
                X300T.Reboot();
            }
        }

        public static void WaitForDhcp()
        {
            if (!_noNative)
            {
                X300T.WaitForDhcp();
            }
        }

        public static int TV2Engine_LoadHal()
        {
            if (_noNative)
            {
                return 1;
            }
            else
            {
                return X300T.TV2Engine_LoadHal();
            }
        }

	}
}

