﻿using System;

using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Booter
{
    class Memory
    {
        public struct MemoryStatus
        {
            internal uint dwLength;
            /// <summary>
            /// Specifies a number between 0 and 100 that gives a general idea of current memory utilization, in which 0 indicates no memory use and 100 indicates full memory use.
            /// </summary>
            public int MemoryLoad;
            /// <summary>
            /// Indicates the total number of bytes of physical memory.
            /// </summary>
            public int TotalPhysical;
            /// <summary>
            /// Indicates the number of bytes of physical memory available.
            /// </summary>
            public int AvailablePhysical;
            /// <summary>
            /// Indicates the total number of bytes that can be stored in the paging file. Note that this number does not represent the actual physical size of the paging file on disk.
            /// </summary>
            public int TotalPageFile;
            /// <summary>
            /// Indicates the number of bytes available in the paging file.
            /// </summary>
            public int AvailablePageFile;
            /// <summary>
            /// Indicates the total number of bytes that can be described in the user mode portion of the virtual address space of the calling process.
            /// </summary>
            public int TotalVirtual;
            /// <summary>
            /// Indicates the number of bytes of unreserved and uncommitted memory in the user mode portion of the virtual address space of the calling process.
            /// </summary>
            public int AvailableVirtual;
        }

        public static MemoryStatus getStatus()
        {
            MemoryStatus ms = new MemoryStatus();
            GlobalMemoryStatusCE(out ms);

//            Writer.WriteLine("Physical mem available: {1}/{2}", ms.AvailablePhysical, ms.TotalPhysical);
//            Writer.WriteLine("Virtual mem available: {1}/{2}", ms.AvailableVirtual, ms.TotalVirtual);
            return ms;
        }

        [DllImport("coredll", EntryPoint = "GlobalMemoryStatus", SetLastError = false)]
        internal static extern void GlobalMemoryStatusCE(out MemoryStatus msce);
    }
}
