﻿/*
 * Datum: 24.09.2007
 * Zeit: 23:59
 * 
 */

using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace Booter.Telnet
{
	/// <summary>
	/// Description of Telnetd.
	/// </summary>
	public class Telnetd
	{
		private int portNum = 23;
		private Thread Thread;
		
		public Telnetd()
		{
		}
		
		public void Listen()
		{
			Socket server = new Socket(AddressFamily.InterNetwork,
			                           SocketType.Stream, ProtocolType.Tcp);
			server.Bind(new IPEndPoint(IPAddress.Any, portNum));
			server.Listen(20);
			Log.debug("TelnetD listening On Port " + portNum.ToString());
			while (true)
			{
				try
				{
					Socket conn = server.Accept();
					new TelnetSession(conn);
				}
				catch (Exception e)
				{
					Log.debug("Error while handling telnet " + e);
				}
			}
		}
		
		public void Start()
		{
			try
			{
				this.Thread = new Thread(new ThreadStart(this.Listen));
                this.Thread.Name = "Telnetd";
				this.Thread.Start();
			}
			catch (Exception e)
			{
				Log.debug("telnetd start thread failed:"+e);
			}
		}
	}
}
